{{- $sharedEnvironment := "shared" }}
{{- $sharedEnvironment = .Values.sharedEnvironment | default $sharedEnvironment -}}
{{- range $key, $val := .Values.environments }}
apiVersion: argoproj.io/v1alpha1
kind: Application
metadata:
  name: "{{ $.Values.rootEnvironment }}-{{ $key }}"
  namespace: argocd
  finalizers:
   - resources-finalizer.argocd.argoproj.io
  annotations:
    argocd.argoproj.io/sync-wave: {{ .syncWave | default "0" | quote }}
spec:
  project: default
  syncPolicy:
    automated:
      #selfHeal: true
      prune: true
      allowEmpty: true
  destination:
    server: https://kubernetes.default.svc
    namespace: "{{ $.Values.rootEnvironment }}-{{ $key }}"
  source:
    path: deployment/applications
    repoURL: {{ $.Values.global.source.repoURL }}
    targetRevision: {{ $.Values.global.source.targetRevision }}
    helm:
      valueFiles:
        - values.yaml
        - values-{{ $val.basedOnEnv }}.yaml
      parameters:
        - name: global.source.repoURL
          value: {{ $.Values.global.source.repoURL }}
        {{- if $val.appName }}
        - name: apps.{{ .appName }}.image.tag
          value: {{ $val.appTag }}
        {{- end }}
        - name: global.sharedEnvironment
          value: {{ $.Values.rootEnvironment }}-{{ $sharedEnvironment }}-infra
        - name: global.rootEnvironment
          value: {{ $.Values.rootEnvironment }}
        - name: global.ingressDomain
          value: {{ $.Values.ingressDomain }}
        - name: global.shortNameEnv
          value: {{ $key }}
        {{- if $.Values.traefikForwardAuthEnabled }}
        - name: global.traefikForwardAuthEnabled
          value: {{ $.Values.traefikForwardAuthEnabled }}
        {{- end }}

---
{{- end }}